//+------------------------------------------------------------------+
//|                                                 A Hanafy_mod.mq4 |
//|                                                              A H |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "A H"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_width1 1
#property indicator_color2 Magenta
#property indicator_width2 1
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
extern int RSI         =14;
extern double PSAR_1   =0.02; 
extern double PSAR_2   =0.2;
extern int Dist        =50;  

extern string FontName="Arial Narrow";
extern int FontSize=14;
extern color FontColor=Gold;
extern int Corner=0;// values [0-3] -  
extern int XDistance=250;// x    
extern int YDistance=0;// y         

int lenbase;
string s_base=":...:...:...:...:";//       

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexArrow(0,241);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(1,242);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----
   lenbase=StringLen(s_base);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  if (ObjectFind("BarTimer") != -1) ObjectDelete("BarTimer");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if (counted_bars<0) return(-1); 

//---- last counted bar will be recounted 

if (counted_bars>0) counted_bars--; 

int pos=Bars-counted_bars; 

while(pos>=0)
 {
   int i=0,sec=0;
   double pc=0.0;
   string time="",s_end="",s_beg="";
   if (ObjectFind("BarTimer") == -1) {//     -    
     ObjectCreate("BarTimer" , OBJ_LABEL,0,0,0);
     ObjectSet("BarTimer", OBJPROP_XDISTANCE, XDistance);
     ObjectSet("BarTimer", OBJPROP_YDISTANCE, YDistance);
     ObjectSet("BarTimer", OBJPROP_CORNER, Corner);
   }

{  

 //buy 
  if((iRSI(NULL,0,RSI,PRICE_CLOSE,pos)>=30 &&iSAR(NULL,0,PSAR_1,PSAR_2,pos)<Low[pos])
  && iRSI(NULL,0,RSI,PRICE_CLOSE,pos)>iRSI(NULL,0,RSI,PRICE_CLOSE,pos+1)
  && iRSI(NULL,0,RSI,PRICE_CLOSE,pos)>iRSI(NULL,0,RSI,PRICE_CLOSE,pos+2))
  {
   
  ExtMapBuffer1[pos]=Low[pos]- Dist*Point ;
  }
    else
    {
    ExtMapBuffer1[pos]=0;
    } 
  //sell

  if((iRSI(NULL,0,RSI,PRICE_CLOSE,pos)<=70 &&iSAR(NULL,0,PSAR_1,PSAR_2,pos)> High[pos])
  && iRSI(NULL,0,RSI,PRICE_CLOSE,pos)<iRSI(NULL,0,RSI,PRICE_CLOSE,pos+1)
  && iRSI(NULL,0,RSI,PRICE_CLOSE,pos)<iRSI(NULL,0,RSI,PRICE_CLOSE,pos+2))
  {
  ExtMapBuffer2[pos]=High[pos]+Dist*Point;
  
  
  } 
 
  else
    {
    ExtMapBuffer2[pos]=0;
    } 
    
    pos--; 
}
//----
sec=TimeCurrent()-Time[0];//      
   i=(lenbase-1)*sec/(Period()*60);//  
   pc=100.0*sec/(Period()*60);//      
   if(i>lenbase-1) i=lenbase-1;//    
   if(i>0) s_beg=StringSubstr(s_base,0,i);
   if(i<lenbase-1) s_end=StringSubstr(s_base,i+1,lenbase-i-1);
   time=StringConcatenate(s_beg,"|",s_end,"  ",DoubleToStr(pc,0),"%");
   ObjectSetText("BarTimer", time, FontSize, FontName, FontColor);
//----
  }
  }
//+------------------------------------------------------------------+